import { renderless, api } from '@opentinyvue/vue-renderless/standard-list-item/vue';
import { defineComponent, $prefix, setup, $props } from '@opentinyvue/vue-common';
import Dropdown from '@opentinyvue/vue-dropdown';
import DropdownMenu from '@opentinyvue/vue-dropdown-menu';
import DropdownItem from '@opentinyvue/vue-dropdown-item';
import Tooltip from '@opentinyvue/vue-tooltip';
import UserHead from '@opentinyvue/vue-user-head';
import TagGroup from '@opentinyvue/vue-tag-group';
import { iconEllipsis } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var __vue2_script = defineComponent({
  name: $prefix + "StandardListItem",
  emits: ["icon-click", "click"],
  components: {
    TinyTooltip: Tooltip,
    TinyUserHead: UserHead,
    TinyTagGroup: TagGroup,
    TinyDropdown: Dropdown,
    TinyDropdownMenu: DropdownMenu,
    TinyDropdownItem: DropdownItem,
    IconEllipsis: iconEllipsis()
  },
  props: _extends({}, $props, {
    data: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    tag: {
      type: Object,
      default: function _default2() {
        return {};
      }
    },
    selected: {
      type: Boolean,
      default: false
    },
    showImage: {
      type: Boolean,
      default: false
    },
    icon: {
      type: Object,
      default: function _default3() {
        return {};
      }
    },
    userHead: {
      type: Object,
      default: function _default4() {
        return {};
      }
    },
    options: {
      type: Array,
      default: function _default5() {
        return [];
      }
    },
    iconMore: {
      type: [Object, String],
      default: function _default6() {
        return iconEllipsis();
      }
    },
    type: {
      type: String,
      default: "list"
    },
    titleOption: {
      type: Object,
      default: function _default7() {
        return {};
      }
    },
    customClass: {
      type: String,
      default: ""
    }
  }),
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex w-full min-h-[theme(spacing.11)] sm:min-h-[theme(spacing.12)] text-xs",
    class: _vm.m(_vm.type === "card" ? "p-3 border-0.5 hover:shadow sm:border rounded border-color-border-separator mb-2 [&:last-child]:mb-0" : "px-0 py-3 border-b-0.5 sm:border-b-px border-b-color-border-separator [&:last-child]:border-none", _vm.type === "card" && _vm.selected ? "border border-color-brand" : "", _vm.customClass),
    attrs: {
      "data-tag": "tiny-standard-list-item"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.showImage || _vm.slots.image && _vm.slots.image() ? _c("div", {
    staticClass: "float-left items-center mr-2.5 shrink-0",
    class: [_vm.icon.name ? "block" : "block sm:flex"],
    attrs: {
      "data-tag": "tiny-standard-list-item-image"
    }
  }, [_vm._t("image", function() {
    return [_vm.icon.name ? _c(_vm.icon.name, {
      tag: "component",
      staticClass: "w-5 h-5",
      style: {
        fill: _vm.icon.color
      }
    }) : _c("tiny-user-head", {
      attrs: {
        "type": _vm.userHead.type || "icon",
        "min": _vm.userHead.min,
        "round": _vm.userHead.round,
        "color": _vm.userHead.color,
        "background-color": _vm.userHead.backgroundColor,
        "size": _vm.userHead.size
      },
      model: {
        value: _vm.userHead.value,
        callback: function callback($$v) {
          _vm.$set(_vm.userHead, "value", $$v);
        },
        expression: "userHead.value"
      }
    })];
  })], 2) : _vm._e(), _c("div", {
    staticClass: "text-left overflow-auto flex-auto mx-0 my-auto leading-5",
    attrs: {
      "data-tag": "tiny-standard-list-item-title"
    }
  }, [_vm._t("default", function() {
    return [_c("div", {
      staticClass: "text-sm flex items-center"
    }, [_vm._t("title", function() {
      return [_c("span", {
        class: _vm.m("mr-3 shrink-0 text-color-text-primary leading-5.5", _vm.titleOption.role === "a" && "cursor-pointer text-color-brand", _vm.titleOption.class || ""),
        on: {
          "click": function click($event) {
            $event.stopPropagation();
            return _vm.handleTitleClick.apply(null, arguments);
          }
        }
      }, [_vm._v(_vm._s(_vm.data.title || ""))])];
    }), _c("span", {
      staticClass: "text-color-text-placeholder shrink-0"
    }, [_vm._v(_vm._s(_vm.data.subTitle || ""))]), _vm._t("tag", function() {
      return [_vm.tag ? _c("tiny-tag-group", {
        staticClass: "inline-block ml-3 text-xs [&_span]:whitespace-nowrap",
        attrs: {
          "data": _vm.tag.data,
          "size": _vm.tag.size,
          "effect": _vm.tag.effect
        }
      }) : _vm._e()];
    })], 2), _c("tiny-tooltip", {
      attrs: {
        "effect": "light",
        "content": _vm.state.descTooltip,
        "placement": "top"
      },
      nativeOn: {
        "mouseenter": function mouseenter($event) {
          return _vm.handleEnterDesc.apply(null, arguments);
        }
      }
    }, [_vm.data.desc ? _c("p", {
      staticClass: "mt-2 text-xs line-clamp-2 sm:line-clamp-1 text-color-text-primary"
    }, [_vm._v(" " + _vm._s(_vm.data.desc) + " ")]) : _vm._e()])];
  })], 2), _vm.state.effectOptions.length || _vm.slots.operate && _vm.slots.operate() ? _c("div", {
    staticClass: "w-auto pr-0 pl-6 h-auto flex items-center justify-center shrink-0 text-color-text-primary",
    attrs: {
      "data-tag": "tiny-standard-list-item-operate"
    }
  }, [_vm._t("operate", function() {
    return [_vm._l(_vm.state.effectOptions.slice(0, _vm.state.sliceNum), function(item, index) {
      return _c("div", {
        key: item.text + index,
        staticClass: "cursor-pointer mr-5 hidden sm:block",
        class: [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
        on: {
          "click": function click($event) {
            $event.stopPropagation();
            return _vm.handelIconClick(item, index, $event);
          }
        }
      }, [_c(item.icon, {
        tag: "component",
        staticClass: "w-4 h-4",
        class: [item.disabled ? "fill-color-icon-disabled" : ""]
      }), item.text ? _c("span", {
        staticClass: "ml-1 align-middle"
      }, [_vm._v(_vm._s(item.text))]) : _vm._e()], 1);
    }), _vm.state.effectOptions.length === _vm.state.iconNum ? _c("div", {
      staticClass: "cursor-pointer hidden sm:block",
      class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
      on: {
        "click": function click($event) {
          $event.stopPropagation();
          return _vm.handelIconClick(_vm.state.effectOptions[_vm.state.sliceNum], _vm.state.sliceNum, $event);
        }
      }
    }, [_c(_vm.state.effectOptions[_vm.state.sliceNum].icon, {
      tag: "component",
      staticClass: "w-4 h-4",
      class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "fill-color-icon-disabled" : ""]
    }), _vm.state.effectOptions[_vm.state.sliceNum].text ? _c("span", {
      staticClass: "ml-1 align-middle"
    }, [_vm._v(_vm._s(_vm.state.effectOptions[_vm.state.sliceNum].text))]) : _vm._e()], 1) : _vm._e(), _vm.state.effectOptions.length > _vm.state.iconNum ? _c("div", {
      staticClass: "h-4 hidden sm:block",
      attrs: {
        "data-tag": "tiny-standard-list-item-selficon"
      }
    }, [_c("tiny-dropdown", {
      attrs: {
        "show-self-icon": ""
      },
      nativeOn: {
        "click": function click($event) {
          $event.stopPropagation();
        }
      },
      scopedSlots: _vm._u([{
        key: "dropdown",
        fn: function fn() {
          return [_c("tiny-dropdown-menu", {
            attrs: {
              "placement": "bottom"
            }
          }, _vm._l(_vm.state.effectOptions.slice(_vm.state.sliceNum), function(item, index) {
            return _c("tiny-dropdown-item", {
              key: item.text + index
            }, [_c("div", {
              class: [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
              on: {
                "click": function click($event) {
                  $event.stopPropagation();
                  return _vm.handelIconClick(item, index + _vm.state.sliceNum, $event);
                }
              }
            }, [_c(item.icon, {
              tag: "component",
              staticClass: "w-4 h-4",
              class: [item.disabled ? "fill-color-icon-disabled" : ""]
            }), item.text ? _c("span", [_vm._v(_vm._s(item.text))]) : _vm._e()], 1)]);
          }), 1)];
        },
        proxy: true
      }], null, false, 872709403)
    }, [_c(_vm.iconMore, {
      tag: "component",
      staticClass: "w-4 h-4"
    }), _vm.state.effectOptions[0].text ? _c("span", {
      staticClass: "ml-1 text-color-text-primary"
    }, [_vm._v(_vm._s(_vm.t("ui.base.more")))]) : _vm._e()], 1)], 1) : _vm._e(), _vm.state.effectOptions.length ? _c("div", {
      staticClass: "block sm:hidden",
      attrs: {
        "data-tag": "tiny-standard-list-item-selficon"
      }
    }, [_c("tiny-dropdown", {
      attrs: {
        "show-self-icon": ""
      },
      nativeOn: {
        "click": function click($event) {
          $event.stopPropagation();
        }
      },
      scopedSlots: _vm._u([{
        key: "dropdown",
        fn: function fn() {
          return [_c("tiny-dropdown-menu", {
            attrs: {
              "placement": "bottom"
            }
          }, _vm._l(_vm.state.effectOptions, function(item, index) {
            return _c("tiny-dropdown-item", {
              key: item.text + index
            }, [_c("div", {
              class: [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
              on: {
                "click": function click($event) {
                  $event.stopPropagation();
                  return _vm.handelIconClick(item, index, $event);
                }
              }
            }, [_c(item.icon, {
              tag: "component",
              staticClass: "w-4 h-4",
              class: [item.disabled ? "fill-color-icon-disabled" : ""]
            }), item.text ? _c("span", [_vm._v(_vm._s(item.text))]) : _vm._e()], 1)]);
          }), 1)];
        },
        proxy: true
      }], null, false, 695159695)
    }, [_c(_vm.iconMore, {
      tag: "component",
      staticClass: "w-4 h-4"
    })], 1)], 1) : _vm._e()];
  })], 2) : _vm._e()]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var StandardListItem = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.23.0";
StandardListItem.install = function(Vue) {
  Vue.component(StandardListItem.name, StandardListItem);
};
StandardListItem.version = version;

export { StandardListItem as default };
